﻿define([
// Dojo
    "dojo/_base/declare",
    "dijit/registry",
        // Dijit
    "dijit/_TemplatedMixin",
    "dijit/_Container",
    "dijit/layout/_LayoutWidget",
    "dijit/_WidgetsInTemplateMixin",
    "epi-cms/_ContentContextMixin",
    "epi/dependency",
    "epi/routes",
//Custom
    "workspace/components/WorkspaceGrid",
    "workspace/commands/AddCurrentItem",
    "workspace/commands/ClearItems",
    "workspace/commands/Settings",
    "epi/shell/command/_WidgetCommandProviderMixin",
    "dojo/text!./Workspaces.html"
], function (
// Dojo
    declare,
    registry,
// Dijit
    _TemplatedMixin,
    _Container,
    _LayoutWidget,
    _WidgetsInTemplateMixin,
    _ContentContextMixin,
    dependency,
    routes,

    WorkspaceGrid,
    AddCurrentItem,
    ClearItems,
    Settings,
    _WidgetCommandProviderMixin,
    template
) {

    return declare(
        [_Container, _LayoutWidget, _TemplatedMixin, _WidgetsInTemplateMixin, _ContentContextMixin, _WidgetCommandProviderMixin], {
            templateString: template,
            widgetsInTemplate: true,
            store: null,
            context: null,

            contextChanged: function (context, callerData) {            
                this.context = context;
                this.inherited(arguments);
            },
                
            _getRestPath: function (name) {
                return routes.getRestPath({ moduleArea: "lionbridgeconnector", storeName: name }); //moduleArea: 'app' for internal build | lionbridgeconnector for external build
            },
            //_publishNow: function() {
            //    this.store.put('-2');
            //    this._reloadGrid();
            //},
            _store: function () {
                var registry = dependency.resolve("epi.storeregistry");
                //this.store = this.store || registry.get("workspace.workspacestore");
                if (registry._stores["workspace.workspacestore"] == undefined) {
                    registry.create("workspace.workspacestore", this._getRestPath("workspacestore"));
                    registry.create("workspace.translationprojectstore", this._getRestPath("translationprojectstore"));
                    registry.create("workspace.translationprojecteditorstore", this._getRestPath("translationprojecteditorstore"));
                    registry.create("workspace.translationprojecttreestore", this._getRestPath("translationprojecttreestore"));
                    registry.create("workspace.translationsearchitemsstore", this._getRestPath("translationsearchitemsstore"));
                    registry.create("workspace.publishprojectstore", this._getRestPath("publishprojectstore"));
                    registry.create("workspace.importprojectstore", this._getRestPath("importprojectstore"));
                    registry.create("workspace.settingstore", this._getRestPath("settingstore"));
                }

                this.store = this.store || registry.get("workspace.workspacestore");
                return this.store;
            },

            _reloadGrid: function() {
                this.contentQuery.set("queryParameters", { workspace: 1, page: 1 });
                this.contentQuery.set("queryName", "WorkspaceQuery");
            },

            startup: function () {
                var self = this;

                self.inherited(arguments);
                this._store();

                this.contentQuery.store = this.store;

                this._reloadGrid();

                this.set("commands", [
                    new AddCurrentItem({ store: this.store, contentQuery: this.contentQuery }),
                    //new ClearItems({ store: this.store, contentQuery: this.contentQuery }),
                    new Settings({ typeIdentifiers: this.typeIdentifiers })
                ]);
            }
        });
});
