﻿define([
    "dojo/_base/declare",
    "epi/shell/command/_Command",
    "epi/shell/_ContextMixin"
], function (declare, _Command, _ContextMixin) {

    return declare([_Command, _ContextMixin], {
        contentQuery : null,
        label: "Add Current Page",

        iconClass: "epi-iconPlus",

        constructor: function () {
            // Set the model to the initial context.
            this.set("model", this._currentContext);
        },

        _execute: function () {
            $('.loadingDiv').fadeIn(500);
            var x = this.contentQuery;
            this.store.put(this.model.id).then(function () {
                x.set("queryParameters", { workspace: 1, page: 1 });
                x.set("queryName", "WorkspaceQuery");
                //window.location.reload();
                $('.loadingDiv').fadeOut(500);
            });
        },

        _onModelChange: function () {
            this.set("canExecute", !!this.model);
        },

        contextChanged: function (context) {
            // Update the model to the new context when it changes.
            this.set("model", context);
        }
    });
})