﻿define([
    "dojo/_base/declare",
        "epi/dependency",
            "epi/routes",
"epi/shell/widget/dialog/Alert",
    "epi/shell/command/_Command"
], function (declare, dependency, routes, Alert, _Command) {

    return declare([_Command], {
        store: null,
        contentQuery: null,

        label: "Remove Project",

        category: "context",
        iconClass: "epi-iconClose",
        canExecute: true,

        _execute: function () {
            var registry = dependency.resolve("epi.storeregistry");
            this.store = registry.get("workspace.workspacestore");
            var x = this.contentQuery;
            this.store.remove(this.model.contentLink).then(function () {
                x.set("queryParameters", { workspace: 1, page: 1 });
                x.set("queryName", "WorkspaceQuery");
            });
            
        },

        _onModelChange: function () {
            // summary:
            //      Updates canExecute after the model has been updated. Subclasses should override this method.
            // tags:
            //      protected
            var sendLink = this;
            var registry = dependency.resolve("epi.storeregistry");
            var store = registry.get("workspace.translationprojectstore");
            dojo.when(store.get(this.model.contentLink + "?" + Math.random() * 9999999999), function (item) {
                //if (item.error) {
                //    var errorDialog = new Alert({
                //        heading: "Something went wrong",
                //        description: "Something went wrong due to: " + item.errorMessage
                //    });
                //    errorDialog.show();
                //}
                if (item.status == 1) {
                    sendLink.set("canExecute", false);
                } else {
                    sendLink.set("canExecute", true);
                }
            });
        }
    });
})